-----------------------------------------------------------------------------------------------
-- Client Lua Script for PetPatrol
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- PetPatrol Module Definition
-----------------------------------------------------------------------------------------------
local PetPatrol = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function PetPatrol:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	
	
	self.tImperialList = {
		["ROWSDOWER"] = {"ROWSDOWER",54042},
		["SPOTTED BLUE JABBIT"] = {"SPOTTED BLUE JABBIT",54234},
		["STRAIN-CORRUPTED PUMERA"] = {"STRAIN-CORRUPTED PUMERA",54238},
		["SNOWY PUMERA"] = {"SNOWY PUMERA",54240},
		["TORINE PUMERA PRIDELORD"] = {"TORINE PUMERA PRIDELORD",54254},
		["AUGMENTED ROWSDOWER"] = {"AUGMENTED ROWSDOWER",54278},
		["COTTON CANDY ROWSDOWER"] = {"COTTON CANDY ROWSDOWER",54279},
		["VIND"] = {"VIND",54313},
		["LOPP DEPUTY"] = {"LOPP DEPUTY",54380},
		["CHOMPACABRA"] = {"CHOMPACABRA",54290},
		["DARKSPUR CHOMPACABRA"] = {"DARKSPUR CHOMPACABRA",54294},
		["DEMONIC ROWSDOWER"] = {"DEMONIC ROWSDOWER",54280},
		["DARKSPUR ELITE CHOMPACABRA"] = {"DARKSPUR ELITE CHOMPACABRA",54298},
		["INDIGO SPIKEHORDE"] = {"INDIGO SPIKEHORDE",54299},
		["GOLDCLAW"] = {"GOLDCLAW",54306},
		["INDIGO PROBEBOT"] = {"INDIGO PROBEBOT",54307},
		["PELL PROBEBOT"] = {"PELL PROBEBOT",54309},
		["ELDAN PROBEBOT"] = {"ELDAN PROBEBOT",54311},
		["GOLD-PLATED ELDAN PROBEBOT"] = {"GOLD-PLATED ELDAN PROBEBOT",54312},
		["FUNGUS-ENCRUSTED SNOGLUG"] = {"FUNGUS-ENCRUSTED SNOGLUG",54323},
		["HONEYHIVE BUZZBING"] = {"HONEYHIVE BUZZBING",54326},
		["BUMBLEBUZZ"] = {"BUMBLEBUZZ",54334},
		["STRAIN-CORRUPTED BUZZBING"] = {"STRAIN-CORRUPTED BUZZBING",54335},
		["VULCARRION SCAVENGER"] = {"VULCARRION SCAVENGER",54339},
		["ARMORED FALKRIN WAR VULCARRION"] = {"ARMORED FALKRIN WAR VULCARRION",54341},
		["SCORCHWING'S HATCHLING"] = {"SCORCHWING'S HATCHLING",54345},
		["INTERSTELLAR FRAZ"] = {"INTERSTELLAR FRAZ",54347},
		["GREAT GREY GRIBBON"] = {"GREAT GREY GRIBBON",54349},
		["RAINBOW GRIBBON"] = {"RAINBOW GRIBBON",54350},
		["LAVENDER JELIBOLLI"] = {"LAVENDER JELIBOLLI",54531},
		["METALBARB"] = {"METALBARB",54367},
		["CELERY SPROUTLING"] = {"CELERY SPROUTLING",54368},
		["CARROT SPROUTLING"] = {"CARROT SPROUTLING",54370},
		["TINY BLUE SPLORG"] = {"TINY BLUE SPLORG",54371},
		["DYNAMO"] = {"DYNAMO",54374},
		["PINK SQUIRG SQUISHLING"] = {"PINK SQUIRG SQUISHLING",54376},
		["STRAIN-CORRUPTED SQUIRG SQUISHLING"] = {"STRAIN-CORRUPTED SQUIRG SQUISHLING",54379},
		["LOPP SNOWPAW"] = {"LOPP SNOWPAW",54383},
		["PARTY LOPP"] = {"PARTY LOPP",54384},
		["MOODIE WITCH DOCTOR"] = {"MOODIE WITCH DOCTOR",54385},
		["MOODIE FIGHTER"] = {"MOODIE FIGHTER",54386},
		["MOODIE CHIEFTAIN"] = {"MOODIE CHIEFTAIN",54388},
		["SKEECH SHAMAN"] = {"SKEECH SHAMAN",54390},
		["SKEECH BEASTLORD"] = {"SKEECH BEASTLORD",54391},
		["AUGMENTED SKEECH"] = {"AUGMENTED SKEECH",54392},
		["DARKFEEDER HOOKFOOT"] = {"DARKFEEDER HOOKFOOT",54395},
		["SNOW-CRESTED ROOTBRUTE"] = {"SNOW-CRESTED ROOTBRUTE",54398},
		["GOLDSPINNER SPIDER"] = {"GOLDSPINNER SPIDER",54402},
		["AUGMENTED SPIDER"] = {"AUGMENTED SPIDER",54404},
		["HOWLING PetAIN YETI"] = {"HOWLING PetAIN YETI",54407},
		["BARKBITER TERMINITE"] = {"BARKBITER TERMINITE",54409},
		["NIGHSTALKER RAZORTAIL"] = {"NIGHSTALKER RAZORTAIL",54418},
		["ANNIVERSEROWSDOWER"] = {"ANNIVERSEROWSDOWER",55381},
		["HOLOPARROT"] = {"HOLOPARROT",55558},
	}
		
    return o
end

function PetPatrol:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- PetPatrol OnLoad
-----------------------------------------------------------------------------------------------
function PetPatrol:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("PetPatrol.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	self.nSelectedPet = nil
end

-----------------------------------------------------------------------------------------------
-- PetPatrol OnDocLoaded
-----------------------------------------------------------------------------------------------
function PetPatrol:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "PetPatrolForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)


		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("pp", "OnPetPatrolOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- PetPatrol Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function PetPatrol:RedrawPets()
	local wndPetPopout = self.wndMain:FindChild("PetPopoutList")
	wndPetPopout:DestroyChildren()

	local tPetList = GameLib.GetVanityPetList()
	local splSelected = nil

	for idx, tPetData  in pairs(tPetList) do
		if tPetData.bIsKnown then
			local splPet = tPetData.splObject
			
			if not splSelected then
				splSelected = splPet
			end

			if splPet:GetId() == self.nSelectedPet then
				splSelected = splPet
			end

			local wndCurr = Apollo.LoadForm(self.xmlDoc, "PetBtn", wndPetPopout, self)
			wndCurr:SetSprite(splPet:GetIcon())
			wndCurr:SetData(tPetData)

			if Tooltip and Tooltip.GetSpellTooltipForm then
				wndCurr:SetTooltipDoc(nil)
				Tooltip.GetSpellTooltipForm(self, wndCurr, splPet, {})
			end
		end
	end

	local nCount = #wndPetPopout:GetChildren()
	if nCount > 0 then
		local nMax = 7
		local nMaxHeight = (wndPetPopout:ArrangeChildrenVert(0) / nCount) * nMax
		local nHeight = wndPetPopout:ArrangeChildrenVert(0)

		nHeight = nHeight <= nMaxHeight and nHeight or nMaxHeight

		local nLeft, nTop, nRight, nBottom = self.wndMain:GetAnchorOffsets()

		self.wndMain:SetAnchorOffsets(nLeft, nBottom - nHeight - 74, nRight, nBottom)
		self.wndMain:Show(true)
	else
		self.wndMain:Show(false)
	end
end

function PetPatrol:OnPetBtn(wndHandler, wndControl)
	self.nSelectedPet = wndControl:GetData().nId
	GameLib.SummonVanityPet(self.nSelectedPet)
end

-- on SlashCommand "/pp"
function PetPatrol:OnPetPatrolOn(cmd, args)
	--self.wndMain:Invoke() -- show the window
	
	
	local tAllParams = {}
	local tConcatParams
	local tFoundPet = false
	for sOneParam in string.gmatch(args, "[^%s]+") do
		table.insert(tAllParams, sOneParam)
		tConcatParams = tAllParams[1]
		
		if tAllParams[2] ~= Nil then 
			tConcatParams = tConcatParams .." ".. tAllParams[2]
		end
		
		if	tAllParams[3] ~= Nil then
			tConcatParams = tConcatParams .." ".. tAllParams[3]
		end
		
		if tAllParams[4] ~= Nil then
			tConcatParams = tConcatParams .." "..tAllParams[4]
		end
		
		for _,v in pairs(self.tImperialList) do
			if v[1] == string.upper(tConcatParams) then
				GameLib.SummonVanityPet(v[2])
				tFoundPet = true
			end
		end
	end
	
	if tFoundPet == false then
		self:RedrawPets()
	end
	
end

function PetPatrol:SummonPet()
	local tPetList = GameLib.GetVanityPetList() 

	if GameLib.GetPlayerUnit():IsCasting() then
		return
	end

	for idx = 1, #tPetList do 
		local tSelectedPet = tPetList[idx]
		
		if tSelectedPet.bIsKnown then 
			GameLib.SummonVanityPet(tSelectedPet.nId)
			return
		end 
	end
end

-----------------------------------------------------------------------------------------------
-- PetPatrolForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function PetPatrol:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function PetPatrol:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- PetPatrol Instance
-----------------------------------------------------------------------------------------------
local PetPatrolInst = PetPatrol:new()
PetPatrolInst:Init()
